/*
 * (c) Copyright 2005, 2006, 2007 Hewlett-Packard Development Company, LP
 * All rights reserved.
 * [See end of file]
 */

package com.hp.hpl.jena.query.engine1.plan;

import java.util.ArrayList;
import java.util.List;
import java.util.ListIterator;

import org.apache.commons.logging.LogFactory;

//import org.apache.commons.logging.*;

import com.hp.hpl.jena.graph.Triple;
import com.hp.hpl.jena.query.ARQ;
import com.hp.hpl.jena.query.engine.QueryIterator;
import com.hp.hpl.jena.query.engine1.*;
import com.hp.hpl.jena.query.engine1.iterator.QueryIterBlockTriples;
import com.hp.hpl.jena.query.util.Context;
import com.hp.hpl.jena.query.util.Symbol;
import com.hp.hpl.jena.query.util.Utils;


/**  
 * @author Andy Seaborne
 * @version $Id: PlanBlockTriples.java,v 1.13 2007/01/02 11:19:33 andy_seaborne Exp $
 */

public class PlanBlockTriples extends PlanElement0
{
    public static Symbol altMatcher = new Symbol(ARQ.arqNS+"altmatcher") ;
    
    public static void enableAltMatcher()
    {
        ARQ.getContext().set(altMatcher, true) ;
    }
    
    //private static Log log = LogFactory.getLog(PlanBasePattern.class) ;
    List triples = null ;
    
    public static PlanElement make(Context context)
    { return new PlanBlockTriples(context) ; }
        
    public PlanBlockTriples(Context context)
    {
        super(context) ;
        triples = new ArrayList() ;
    }
    
    public void addTriple(Triple t) { triples.add(t) ; }
    
    public ListIterator triples() { return triples.listIterator() ; }
    public List getPattern() { return triples ; }
    
    public QueryIterator build(QueryIterator input, ExecutionContext execCxt)
    {
        if ( input == null )
            LogFactory.getLog(this.getClass()).fatal("Null input to "+Utils.classShortName(this.getClass())) ;
        QueryIterator cIter = QueryIterBlockTriples.create(input, triples, execCxt) ;
        return cIter ;
    }

    public void visit(PlanVisitor visitor) { visitor.visit(this) ; }

    public PlanElement apply(Transform transform)  { return transform.transform(this) ; }

    public PlanElement copy()
    {
        PlanBlockTriples pbt = new PlanBlockTriples(getContext()) ;
        pbt.triples.addAll(this.triples) ;
        return pbt ;
    }
}

/*
 * (c) Copyright 2005, 2006, 2007 Hewlett-Packard Development Company, LP
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */