/*
 * (c) Copyright 2005, 2006, 2007 Hewlett-Packard Development Company, LP
 * All rights reserved.
 * [See end of file]
 */

package com.hp.hpl.jena.query.function.library;

import java.io.PrintStream;
import java.io.PrintWriter;
import java.util.List;

//import org.apache.commons.logging.*;
import com.hp.hpl.jena.query.expr.NodeValue;
import com.hp.hpl.jena.query.function.FunctionBase;
import com.hp.hpl.jena.query.util.ExprUtils;
import com.hp.hpl.jena.util.FileUtils;

/** Function that prints its evaluated arguments. 
 * 
 * @author Andy Seaborne
 * @version $Id: print.java,v 1.5 2007/01/04 16:21:47 andy_seaborne Exp $
 */

public class print extends FunctionBase
{
    //private static Log log = LogFactory.getLog(F_even.class) ;
    
    private static PrintWriter out = FileUtils.asPrintWriterUTF8(System.out) ; 
    static public void setStream(PrintStream stream) { out = FileUtils.asPrintWriterUTF8(stream) ; }  
    
    public void checkBuild(String uri, List args)
    {} 
    
    /** Processes evaluated args */
    public NodeValue exec(List args)
    {
        if ( args.size() == 0 )
            out.println() ;
        else
            out.println(ExprUtils.joinList(args, " ")) ;
        out.flush() ;
        return NodeValue.TRUE ;
    }

}

/*
 * (c) Copyright 2005, 2006, 2007 Hewlett-Packard Development Company, LP
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */